using System;
using System.Collections.Generic;
using System.Text;
using Guushuuse.SalaryPrj.HR.DomainModel;
using Guushuuse.SalaryPrj.HR.Service;
using System.Collections;

namespace Guushuuse.SalaryPrj.HR.Helper
{
    /// <summary>
    /// 
    /// </summary>
    public class HRHelper
    {
        /// <summary>
        /// 
        /// </summary>
        /// <param name="code"></param>
        /// <param name="name"></param>
        public static void CreateDept(string code, string name)
        {
            try
            {
                Dept dept = new Dept();
                dept.Code = code;
                dept.Name = name;

                ServiceLocator.DeptService.CreateDept(dept);
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        /// <summary>
        /// ²
        /// </summary>
        /// <param name="id"></param>
        /// <param name="code"></param>
        /// <param name="name"></param>
        public static void UpdateDept(int id, string code, string name)
        {
            try
            {
                Dept dept = ServiceLocator.DeptService.GetDept(id);
                dept.Code = code;
                dept.Name = name;

                ServiceLocator.DeptService.CreateDept(dept);
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        /// <summary>
        /// ɾ
        /// </summary>
        /// <param name="id"></param>
        /// <param name="code"></param>
        /// <param name="name"></param>
        public static void DeleteDept(int id)
        {
            try
            {
                Dept dept = ServiceLocator.DeptService.GetDept(id);
                
                ServiceLocator.DeptService.DeleteDept(dept);
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        /// <summary>
        /// ȡв
        /// </summary>
        /// <returns></returns>
        public static IList GetAllDepts()
        {
            IList depts;

            try
            {
                depts = ServiceLocator.DeptService.GetAllDepts();
            }
            catch (Exception ex)
            {
                throw ex;
            }

            return depts;
       }

        /// <summary>
        /// Ա
        /// </summary>
        /// <param name="code"></param>
        /// <param name="name"></param>
        /// <param name="deptID"></param>
        public static void CreateEmployee(string code, string name, int deptID)
        {
            try
            {
                Employee employee = new Employee();
                employee.Code = code;
                employee.Name = name;
                employee.Dept = ServiceLocator.DeptService.GetDept(deptID);

                ServiceLocator.EmployeeService.CreateEmployee(employee);
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        /// <summary>
        /// Ա
        /// </summary>
        /// <param name="id"></param>
        /// <param name="code"></param>
        /// <param name="name"></param>
        /// <param name="deptID"></param>
        public static void UpdateEmployee(int id, string code, string name, int deptID)
        {
            try
            {
                Employee employee = ServiceLocator.EmployeeService.GetEmployee(id);
                employee.Code = code;
                employee.Name = name;
                employee.Dept = ServiceLocator.DeptService.GetDept(deptID);

                ServiceLocator.EmployeeService.CreateEmployee(employee);
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        /// <summary>
        /// ɾԱ
        /// </summary>
        /// <param name="id"></param>
        /// <param name="code"></param>
        /// <param name="name"></param>
        public static void DeleteEmployee(int id)
        {
            try
            {
                Employee employee = ServiceLocator.EmployeeService.GetEmployee(id);

                ServiceLocator.EmployeeService.DeleteEmployee(employee);
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        /// <summary>
        /// ȡԱ
        /// </summary>
        /// <returns></returns>
        public static IList GetAllEmployees()
        {
            IList employees;

            try
            {
                employees = ServiceLocator.EmployeeService.GetAllEmployees();
            }
            catch (Exception ex)
            {
                throw ex;
            }

            return employees;
        }
    }
}
